unit Report;
  (* Print report from tbTables & tbFields.  Form used modally *)

  interface
    uses
      Buttons  (* tBitBtn *),
      Classes,
      Controls,
      ExtCtrls,
      Forms    (* tForm, tScrollBox *),
      MyUtils  (* tRRFCloseBtn *),
      QRCtrls  (* tQRDBText, tQRLabel, tQRSysData *),
      QuickRpt (* tQRBand, tQRCustomBand, tQRSubDetail, tQuickRep *),
      StdCtrls,
      Windows;

    type
      tfmReport = class(tForm)
          btnPreview: tBitBtn;
          qrReport: tQuickRep;
          btnClose: tRRFCloseBtn;
          scrlReport: tScrollBox;

          qrbdPageHeader: tQRBand;
          qrlbDataBase:     tQRLabel;
          qrlbDataBaseName: tQRLabel;
          qrsysPageNumber: tQRSysData;

          qrbdTable:      tQRBand;
          qrdbtxRecordCount:      tQRDBText;
          qrdbtxTableDescription: tQRDBText;
          qrdbtxTableName:        tQRDBText;
          qrlbTable:       tQRLabel;
          qrlbRecordCount: tQRLabel;

          qrbdFieldHeader: tQRBand;
          qrlbField:            tQRLabel;
          qrlbFieldDescription: tQRLabel;
          qrlbFieldType:        tQRLabel;
          qrlbRequired:         tQRLabel;
          qrlbSize:             tQRLabel;

          qrsubbdFields: tQRSubDetail;
          qrdbtxField:            tQRDBText;
          qrdbtxFieldDescription: tQRDBText;
          qrdbtxFieldType:        tQRDBText;
          qrdbtxSize:             tQRDBText;
          qrlbReqd: tQRLabel;

          qrbdPageFooter: tQRBand;
          qrsysDateTime: tQRSysData;
          procedure btnPreviewClick(Sender: tObject);
          procedure qrsubbdFieldsBeforePrint(Sender: tQRCustomBand;
                                             var PrintBand: boolean);
        private
          procedure SetUpFields;
        end (* tfmReport *);

  implementation
    uses
      TableTableDM (* dmTableTable *);
      {$R *.dfm}

    procedure tfmReport.btnPreviewClick(Sender: tObject);
      (* move toward printing *)

      begin (* tfmReport.btnPreviewClick *)
        SetUpFields;
        with qrReport do
          if Available then
            Preview
      end   (* tfmReport.btnPreviewClick *);

    procedure tfmReport.qrsubbdFieldsBeforePrint(Sender: tQRCustomBand;
                                                 var PrintBand: boolean);
      (* Produce printable entry for Required *)

      begin (* tfmReport.qrsubbdFieldsBeforePrint *)
        with dmTableTable.tbTableFields.FieldByName('Required') do
          if AsBoolean then
            qrlbReqd.Caption := 'yes'
          else
            qrlbReqd.Caption := 'no';
        PrintBand := true
      end   (* tfmReport.qrsubbdFieldsBeforePrint *);

    procedure tfmReport.SetUpFields;
      (* Global initialization before printing *)

      begin (* tfmReport.SetUpFields *)
        qrlbDataBaseName.Caption := dmTableTable.tbTables.DatabaseName
      end   (* tfmReport.SetUpFields *);

end.
