unit TableTableDM;
  (* service module for TableTable application *)

  interface
    uses
      Classes  (* tDataModule, tDataSource *),
      DB       (* tBooleanField, tDataSet, tIntegerField, tMemoField,
                    tSmallIntField, tStringField *),
      DBTables (* tTable *);

    type
      tdmTableTable = class(tDataModule)
          dataFields: tDataSource;
          tbFields: tTable;
          tbFieldsRequired: tBooleanField;
          tbFieldsSize: tSmallintField;
          tbFieldsDescription: tStringField;
          tbFieldsFieldName:   tStringField;
          tbFieldsFieldType:   tStringField;
          tbFieldsTableName:   tStringField;

          dataTables: tDataSource;
          tbTables: tTable;
          tbTablesRecordCount: tIntegerField;
          tbTablesDescription: tMemoField;
          tbTablesTableName: tStringField;

          tbTableFields: tTable;
          tbTableFieldsRequired: tBooleanField;
          tbTableFieldsSize: tSmallintField;
          tbTableFieldsDescription: tStringField;
          tbTableFieldsFieldName:   tStringField;
          tbTableFieldsFieldType:   tStringField;
          tbTableFieldsTableName:   tStringField;
          procedure DataModuleCreate(Sender: tObject);
          procedure InsertionMonitor(DataSet: tDataSet);
        public
          InsertionOK: boolean;
        end (* tdmTableTable *);

    var
      dmTableTable: tdmTableTable;

  implementation
    uses
      SysUtils (* Abort *);
      {$R *.dfm}

    procedure tdmTableTable.DataModuleCreate(Sender: tObject);
      (* Initialize *)

      begin (* tdmTableTable.DataModuleCreate *)
        InsertionOK := false
      end   (* tdmTableTable.DataModuleCreate *);

    procedure tdmTableTable.InsertionMonitor(DataSet: tDataSet);
      (* Avoid autoinsertion from running off the end of grids *)

      begin (* tdmTableTable.InsertionMonitor *)
        if not InsertionOK then
          Abort
      end   (* tdmTableTable.InsertionMonitor *);

end.
